#include "delay.h"
#include "stm32f4xx.h"

////////////////////////////////////////// 	 
static u8   fac_us=0;//usʱ 21
static u16  fac_ms=0;//msʱ 21000

void delay_init()	 
{
	static int sysclk;
	sysclk=SystemCoreClock;//ϵͳʱ168mhz
	
	SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);	//ѡⲿʱ  HCLK/8
	fac_us= sysclk / 8000000;	//21mhz,211us
	fac_ms=fac_us*1000;

	 
}								    


//ʱnus
//nusΪҪʱus.	
//21M,nus<=798915us
void delay_us(u32 nus)
{		
	u32 temp;	    	 
	SysTick_Config(nus*fac_us);
	//Ƿ񳬷Χ
	if(nus*fac_us > SysTick_LOAD_RELOAD_Msk)SysTick_Config(SysTick_LOAD_RELOAD_Msk);
	do
	{
		temp=SysTick->CTRL;
	}
	while(temp&0x01&&!(temp&(1<<16)));//ȴʱ䵽   
	SysTick->CTRL&=~SysTick_CTRL_ENABLE_Msk;       //رռ
	SysTick->VAL =0X00;       //ռ	 
}
//ʱnms
//עnmsķΧ
//SysTick->LOADΪ24λĴ,,ʱΪ:
//nms<=0xffffff*8*1000/SYSCLK
//SYSCLKλΪHz,nmsλΪms
//21M,nms<=798 ms
void delay_ms(u16 nms)//21M,nms<= 798   ms
{	 		  	  
	u32 temp;		   
	SysTick_Config(nms*fac_ms);
	//Ƿ񳬷Χ
	if(nms*fac_ms > SysTick_LOAD_RELOAD_Msk)SysTick_Config(SysTick_LOAD_RELOAD_Msk);
	do
	{
		temp=SysTick->CTRL;
	}
	while(temp&0x01&&!(temp&(1<<16)));//ȴʱ䵽   
	SysTick->CTRL&=~SysTick_CTRL_ENABLE_Msk;       //رռ
	SysTick->VAL =0X00;       //ռ	  	    
} 



 void SysTick_Handler()//ʱж
 {
	 
 
 
 
 }




























