//#ifndef __NRF24L01PLUS_H
//#define __NRF24L01PLUS_H

#ifndef nrf24l01plus_h
#define nrf24l01plus_h

#include "stm32f4xx.h"
#include "spi.h"

//nrF24L01+ģ
//qq750273008
//2018.2.17޸

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//NRF24L01Ĵ
#define NRF_READ_REG    0x00  //üĴ,5λΪĴַ 000A AAAA
#define NOP             0xFF  //ղ,״̬Ĵ
#define NRF_WRITE_REG   0x20  // 1<<5 дüĴ,5λΪĴַ 001A AAAA

#define RX_9bit         0x60  //ȡ֡9bitݰ
#define RD_RX_PLOAD     0x61  //RXЧ,1~32ֽ
#define WR_TX_PLOAD     0xA0  //дTXЧ,1~32ֽ
#define FLUSH_TX        0xE1  //TX FIFOĴ.ģʽ(շͰ)
#define FLUSH_RX        0xE2  //RX FIFOĴ.ģʽãսհ
//ط
#define REUSE_TX_PL     0xE3  //ʹһ,CEΪ,ݰϷ.ط
#define NO_ACK_TX_PL    0xB0  //Ӧģʽطݰ
#define TX_PID          0xA8  //1010.1ppp Э֡PID,pppΧ0~51ʼ

//SPI(NRF24L01)Ĵַ
#define CONFIG          0x00  //üĴַ;bit0:1ģʽ,0ģʽ;bit1:ѡ;bit2:CRCģʽ;bit3:CRCʹ;
                              //bit4:жMAX_RT(ﵽطж)ʹ;bit5:жTX_DSʹ;bit6:жRX_DRʹ
#define EN_ACK          0x01  //ʹԶӦ  bit0~5,Ӧͨ0~5
#define EN_RXADDR       0x02  //յַ,bit0~5,Ӧͨ0~5
#define SETUP_AW        0x03  //õַ(ͨ)[1:0]00Ƿ01:3ֽڣ10:4ֽڣ11:5ֽ
#define SETUP_RETR      0x04  //Զط;bit3:0,Զط;bit7:4,Զطʱ 250*x+86us
#define RF_CH           0x05  //RFͨ,bit6:0,ͨƵ;
#define RF_SETUP        0x06  //RFĴ;bit3:(0:1Mbps,1:2Mbps);bit2:1,书;bit0:Ŵ
#define STATUS          0x07  //״̬Ĵ;bit0:TX FIFO־;bit3:1,ͨ(:6);bit4,ﵽط
                              //bit5:ݷж;bit6:ж;
#define OBSERVE_TX      0x08  //ͼĴ,bit7:4,ݰʧ;bit3:0,ط
#define CD              0x09  //زĴ,bit0,ز;
#define RX_ADDR_P0      0x0A  //P0յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P1      0x0B  //P1յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P2      0x0C  //P2յַ,ֽڲſ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P3      0x0D  //P3յַ,ֽڲſ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P4      0x0E  //P4յַ,ֽڲſ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P5      0x0F  //P5յַ,ֽڲſ,ֽ,ͬRX_ADDR_P1[39:8];
#define TX_ADDR         0x10  //͵ַ(ֽǰ),ShockBurstTMģʽ,RX_ADDR_P0˵ַ
#define RX_PW_P0        0x11  //P0Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P1        0x12  //P1Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P2        0x13  //P2Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P3        0x14  //P3Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P4        0x15  //P4Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P5        0x16  //P5Чݿ(1~32ֽ),Ϊ0Ƿ
#define NRF_FIFO_STATUS 0x17  //FIFO״̬Ĵ;bit0,RX FIFOĴձ־;bit1,RX FIFO־;bit2,3,
                              //bit4,TX FIFOձ־;bit5,TX FIFO־;bit6,1,ѭһݰ.0,ѭ;

#define TX_DPL          0x1C  //̬[5:0]ӦP5~P0ַ0x1C.[5:0],0x1D.2,0x01.0,CE=1;
#define TX_DPL_EN       0x1D  //̬ؿƣbit2DPLܿأbit1ACKӦģʽѡbit0Ӧģʽѡ

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//ͨѶַD0D1D2......D39//CFQQ0
static const u8 TX_TX[5]={ 0x30, 0x51,0x51,0x46,0x43};//͵ַ,Ĭֽڴӵ͵ߡd7d0d15d8//51822ͨѶu8 to_nrf51822addr(u8 reg, u8 *pBuf, u8 u8s);//дַ
static const u8 RX_P0[5]={ 0x30, 0x51,0x51,0x46,0x43}; //P0ַ//TX±ռýACK
static const u8 RX_P1[5]={ 0x31, 0x51,0x51,0x46,0x43}; //P1յַ
static const u8 RX_P2[1]={ 0x32/*0x51,0x51,0x46,0x43*/}; //P2յַֽںP1ã
static const u8 RX_P3[1]={ 0x33/*0x51,0x51,0x46,0x43*/}; //P3յַP1ֽʲô
static const u8 RX_P4[1]={ 0x34/*0x51,0x51,0x46,0x43*/}; //P4յַ2345ֽھʲô
static const u8 RX_P5[1]={ 0x35/*0x51,0x51,0x46,0x43*/}; //P5յַֽںP1ã
////////////////////////////////////////////////////////////////////////////////// 
//24L01
#define NRF24L01_GND    0 	  //24L01Դ0v
#define NRF24L01_VCC    3.3 	//24L01Դ3.3v
#define NRF24L01_CE     CE 	//24L01ʹܣߵƽЧ
#define NRF24L01_CSN    CSN //spiʹܣ͵ƽЧ
#define NRF24L01_SCK    SCK //spiʱӣЧ
#define NRF24L01_MOSI   MOSI//spiţλMO,λSI룩
#define NRF24L01_MISO   MISO//spiţλMI,λSO
#define NRF24L01_IRQ    IRQ //жϽ(͵ƽ)

//24L01ͽݿȶ
#define address_3    1   	//3ֽڵĵַ0x03Ĵ
#define address_4    2   	//4ֽڵĵַ
#define address_5    3   	//5ֽڵĵַ
#define NO_ACK     0   	//Ӧ
#define ACK        1   	//Ӧ
#define TX_PLOAD_WIDTH  32  	//32ֽڵûݿ
#define RX_PLOAD_WIDTH  32  	//32ֽڵûݿ
									   	   
u8 SPI_ReadWriteByte(u8 byte);//SPI߶дһֽ[d7:d0][d15:d8]
u8 SPI_51822addr(u8 byte);//SPI߶дһֽ[d0:d7][d8:d15]
u8 to_nrf51822addr(u8 reg, u8 *pBuf, u8 u8s);//дַ
/////////д
u8 NRF24L01_Read_Reg(u8 reg);			//Ĵ
u8 NRF24L01_Write_Reg(u8 reg, u8 value);//дĴbit51
/////////ʼ
void NRF24L01_Init(void);//ʼNRF24L01 
void NRF24L01_RX_Mode(void);//Ϊģʽ
void NRF24L01_TX_Mode(void);//Ϊģʽ
u8 NRF24L01_Write_Buf(u8 reg, u8 *pBuf, u8 u8s);//д
u8 NRF24L01_Read_Buf(u8 reg, u8 *pBuf, u8 u8s);//		  
////////
u8 NRF24L01_Check(void);//24L01Ƿ

u8 NRF24L01_TxPack(u8 *txbuf);//һ
u8 NRF24L01_RxPack(u8 *rxbuf);//һ
////////߼
void NRF24L01_RX_DPL_Mode(u8);//Ϊ̬ؽģʽ
void NRF24L01_TX_DPL_Mode(u8);//Ϊ̬طģʽ
void NRF24L01_reg_inspect(void);//Ĵ
void NRF24L01_sleep(void);//ʡػģʽ//˳NRF24L01_RX_Mode(void);//Ϊģʽ
u8 NRF24L01_CD();			//0x09زCD
//////////˫ͨѶbilateral
void NRF24L01_bilateral_A_Init(void);//ʼNRF24L01ΪλA0123ACK,45NO_ACK
void NRF24L01_bilateral_B_Init(void);//ʼNRF24L01ΪλB0123ACK,45NO_ACK

//0x07ʱ
//0x3fʧ
//շһ
u8 NRF24L01_bilateral_Pack(u8 *rxbuf,u8 *txbuf);//0~	5ͨţ0x070x3fʧ
u8 NRF24L01_tx_pack(u8 *txbuf);//
#endif

////////////////////////////////////////////////////////////////////////////////////// 
//static const u8 TX_TX[5]={ 0xE7, 0xE7,0xE7,0xE7,0xE7};//͵ַ,Ĭֽڴӵ͵ߡd7d0d15d8//51822ͨѶu8 to_nrf51822addr(u8 reg, u8 *pBuf, u8 u8s);//дַ
//static const u8 RX_P0[5]={ 0xE7, 0xE7,0xE7,0xE7,0xE7}; //P0ַ
//static const u8 RX_P1[5]={ 0xC2, 0xC2,0xC2,0xC2,0xC2}; //P1յַ
//static const u8 RX_P2[1]={ 0xC3/*0xC2,0xC2,0xC2,0xC2*/}; //P2յַֽںP1ã
//static const u8 RX_P3[1]={ 0xC4/*0xC2,0xC2,0xC2,0xC2*/}; //P3յַP1ֽʲô
//static const u8 RX_P4[1]={ 0xC5/*0xC2,0xC2,0xC2,0xC2*/}; //P4յַ2345ֽھʲô
//static const u8 RX_P5[1]={ 0xC6/*0xC2,0xC2,0xC2,0xC2*/}; //P5յַֽںP1ã
//////////////////////////////////////////////////////////////////////////////////// 




